
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>sqlalchemy(二)高级用法 / iVAN</title>

    <meta name="description" content="sqlalchemy(二)高级用法 本文将介绍sqlalchemy的高级用法. 外键以及relationship 首先创建数据库,在这里一个user对应多个address,因此需要在address上增加user_id这个外键(一对多). #!/usr/bin/env python # encoding: utf-8 from sqlalchemy import create_engine from sqlalchemy import Column from sqlalchemy import Integer from sqlalc">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">sqlalchemy(二)高级用法</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<blockquote><p>本文将介绍sqlalchemy的高级用法。</p></blockquote>
<h2>外键以及relationship</h2>
<p>首先创建数据库，在这里一个user对应多个address，因此需要在address上增加user_id这个外键（一对多）。</p>
<pre><code>#!/usr/bin/env python
# encoding: utf-8

from sqlalchemy import create_engine
from sqlalchemy import Column
from sqlalchemy import Integer
from sqlalchemy import String
from sqlalchemy import ForeignKey
from sqlalchemy.orm import backref
from sqlalchemy.orm import sessionmaker
from sqlalchemy.orm import relationship, backref
from sqlalchemy.ext.declarative import declarative_base

Base = declarative_base()

class User(Base):
    __tablename__ = 'users'

    id = Column(Integer, primary_key=True)
    name = Column(String(32))

    addresses = relationship("Address", order_by="Address.id", backref="user")

class Address(Base):
    __tablename__ = 'addresses'
    id = Column(Integer, primary_key=True)
    email_address = Column(String(32), nullable=False)
    user_id = Column(Integer, ForeignKey('users.id'))

    #user = relationship("User", backref=backref('addresses', order_by=id))

engine  = create_engine('mysql://root:root@localhost:3306/test', echo=True)
#Base.metadata.create_all(engine) </code></pre>
<p>接下来，调用user和address来添加数据，</p>
<pre><code>&gt;&gt;&gt; jack = User(name='jack')
&gt;&gt;&gt; jack.address
Traceback (most recent call last):
  File "&lt;stdin&gt;", line 1, in &lt;module&gt;
AttributeError: 'User' object has no attribute 'address'
&gt;&gt;&gt; jack.addresses
[]
&gt;&gt;&gt; jack.addresses = [Address(email_address='test@test.com'), Address(email_address='test1@test1.com')]
&gt;&gt;&gt; jack.addresses
[&lt;demo.Address object at 0x7f2536564f90&gt;, &lt;demo.Address object at 0x7f2535dc71d0&gt;]
&gt;&gt;&gt; session.add(jack)
&gt;&gt;&gt; session.commit()
2015-08-19 13:45:36,237 INFO sqlalchemy.engine.base.Engine SHOW VARIABLES LIKE 'sql_mode'
2015-08-19 13:45:36,237 INFO sqlalchemy.engine.base.Engine ()
2015-08-19 13:45:36,238 INFO sqlalchemy.engine.base.Engine SELECT DATABASE()
2015-08-19 13:45:36,238 INFO sqlalchemy.engine.base.Engine ()
2015-08-19 13:45:36,239 INFO sqlalchemy.engine.base.Engine show collation where `Charset` = 'utf8' and `Collation` = 'utf8_bin'
2015-08-19 13:45:36,239 INFO sqlalchemy.engine.base.Engine ()
2015-08-19 13:45:36,239 INFO sqlalchemy.engine.base.Engine SELECT CAST('test plain returns' AS CHAR(60)) AS anon_1
2015-08-19 13:45:36,239 INFO sqlalchemy.engine.base.Engine ()
2015-08-19 13:45:36,240 INFO sqlalchemy.engine.base.Engine SELECT CAST('test unicode returns' AS CHAR(60)) AS anon_1
2015-08-19 13:45:36,240 INFO sqlalchemy.engine.base.Engine ()
2015-08-19 13:45:36,240 INFO sqlalchemy.engine.base.Engine SELECT CAST('test collated returns' AS CHAR CHARACTER SET utf8) COLLATE utf8_bin AS anon_1
2015-08-19 13:45:36,240 INFO sqlalchemy.engine.base.Engine ()
2015-08-19 13:45:36,241 INFO sqlalchemy.engine.base.Engine BEGIN (implicit)
2015-08-19 13:45:36,242 INFO sqlalchemy.engine.base.Engine INSERT INTO users (name) VALUES (%s)
2015-08-19 13:45:36,242 INFO sqlalchemy.engine.base.Engine ('jack',)
2015-08-19 13:45:36,243 INFO sqlalchemy.engine.base.Engine INSERT INTO addresses (email_address, user_id) VALUES (%s, %s)
2015-08-19 13:45:36,243 INFO sqlalchemy.engine.base.Engine ('test@test.com', 1L)
2015-08-19 13:45:36,243 INFO sqlalchemy.engine.base.Engine INSERT INTO addresses (email_address, user_id) VALUES (%s, %s)
2015-08-19 13:45:36,243 INFO sqlalchemy.engine.base.Engine ('test1@test1.com', 1L)
2015-08-19 13:45:36,244 INFO sqlalchemy.engine.base.Engine COMMIT
&gt;&gt;&gt; </code></pre>
<p>此时，查看数据库，可以得到刚才插入的数据，</p>
<pre><code>mysql&gt; select * from users;
+----+------+
| id | name |
+----+------+
|  1 | jack |
+----+------+
1 row in set (0.00 sec)

mysql&gt; select * from addresses;
+----+-----------------+---------+
| id | email_address   | user_id |
+----+-----------------+---------+
|  1 | test@test.com   |       1 |
|  2 | test1@test1.com |       1 |
+----+-----------------+---------+
2 rows in set (0.00 sec)</code></pre>
<h2>join查询</h2>
<p>如果不使用join的话，可以直接联表查询，</p>
<pre><code>&gt;&gt;&gt; session.query(User.name, Address.email_address).filter(User.id==Address.user_id).filter(Address.email_address=='test@test.com').all()
2015-08-19 14:02:02,877 INFO sqlalchemy.engine.base.Engine SELECT users.name AS users_name, addresses.email_address AS addresses_email_address
FROM users, addresses
WHERE users.id = addresses.user_id AND addresses.email_address = %s
2015-08-19 14:02:02,878 INFO sqlalchemy.engine.base.Engine ('test@test.com',)
[('jack', 'test@test.com')]</code></pre>
<p>在sqlalchemy中提供了Queqy.join()函数，</p>
<pre><code>&gt;&gt;&gt; session.query(User).join(Address).filter(Address.email_address=='test@test.com').first()
2015-08-19 14:06:56,624 INFO sqlalchemy.engine.base.Engine SELECT users.id AS users_id, users.name AS users_name
FROM users INNER JOIN addresses ON users.id = addresses.user_id
WHERE addresses.email_address = %s
 LIMIT %s
2015-08-19 14:06:56,624 INFO sqlalchemy.engine.base.Engine ('test@test.com', 1)
&lt;demo.User object at 0x7f9a74139a10&gt;
&gt;&gt;&gt; session.query(User).join(Address).filter(Address.email_address=='test@test.com').first().name
2015-08-19 14:07:04,224 INFO sqlalchemy.engine.base.Engine SELECT users.id AS users_id, users.name AS users_name
FROM users INNER JOIN addresses ON users.id = addresses.user_id
WHERE addresses.email_address = %s
 LIMIT %s
2015-08-19 14:07:04,224 INFO sqlalchemy.engine.base.Engine ('test@test.com', 1)
'jack'
&gt;&gt;&gt; session.query(User).join(Address).filter(Address.email_address=='test@test.com').first().addresses
2015-08-19 14:07:06,534 INFO sqlalchemy.engine.base.Engine SELECT users.id AS users_id, users.name AS users_name
FROM users INNER JOIN addresses ON users.id = addresses.user_id
WHERE addresses.email_address = %s
 LIMIT %s
2015-08-19 14:07:06,534 INFO sqlalchemy.engine.base.Engine ('test@test.com', 1)
2015-08-19 14:07:06,535 INFO sqlalchemy.engine.base.Engine SELECT addresses.id AS addresses_id, addresses.email_address AS addresses_email_address, addresses.user_id AS addresses_user_id
FROM addresses
WHERE %s = addresses.user_id ORDER BY addresses.id
2015-08-19 14:07:06,535 INFO sqlalchemy.engine.base.Engine (1L,)
[&lt;demo.Address object at 0x7f9a74139350&gt;, &lt;demo.Address object at 0x7f9a741390d0&gt;]
&gt;&gt;&gt; </code></pre>
<p>注意，上面的用法的前提是存在外键的情况下，如果没有外键，那么可以使用,</p>
<pre><code>query.join(Address, User.id==Address.user_id)    # explicit condition
query.join(User.addresses)                       # specify relationship from left to right
query.join(Address, User.addresses)              # same, with explicit target
query.join('addresses')    </code></pre>
<h2>表的别名</h2>
<pre><code>&gt;&gt;&gt; from sqlalchemy.orm import aliased
&gt;&gt;&gt; adalias1 = aliased(Address)</code></pre>
<h2>子查询</h2>
<p>假设我们需要这样一个查询，</p>
<pre><code>mysql&gt; SELECT users.*, adr_count.address_count FROM users LEFT OUTER JOIN
    -&gt;     (SELECT user_id, count(*) AS address_count
    -&gt;         FROM addresses GROUP BY user_id) AS adr_count
    -&gt;     ON users.id=adr_count.user_id;
+----+------+---------------+
| id | name | address_count |
+----+------+---------------+
|  1 | jack |             2 |
+----+------+---------------+
1 row in set (0.00 sec)
</code></pre>
<pre><code>#　生成子句，等同于（select user_id ... group_by user_id）
&gt;&gt;&gt; sbq = session.query(Address.user_id, func.count('*').label('address_count')).group_by(Address.user_id).subquery()

# 联接子句，注意子句中需要使用c来调用字段内容
&gt;&gt;&gt; session.query(User.name, sbq.c.address_count).outerjoin(sbq, User.id==sbq.c.user_id).all()
2015-08-19 14:42:53,425 INFO sqlalchemy.engine.base.Engine SELECT users.name AS users_name, anon_1.address_count AS anon_1_address_count
FROM users LEFT OUTER JOIN (SELECT addresses.user_id AS user_id, count(%s) AS address_count
FROM addresses GROUP BY addresses.user_id) AS anon_1 ON users.id = anon_1.user_id
2015-08-19 14:42:53,425 INFO sqlalchemy.engine.base.Engine ('*',)
[('jack', 2L)]
&gt;&gt;&gt;</code></pre>
<h2>包含contains</h2>
<pre><code>query.filter(User.addresses.contains(someaddress))</code></pre>
<h2>数据删除delete</h2>
<pre><code>&gt;&gt;&gt; session.delete(jack)
&gt;&gt;&gt; session.query(User).filter_by(name='jack').count()
0</code></pre>
<h2>外键配置</h2>
<p>在上面的例子中，删除了user－jack，但是address中的数据并没有删除。</p>
<p>cascade字段用来</p>
<pre><code>addresses = relationship("Address", backref='user',
    cascade="all, delete, delete-orphan")</code></pre>
<blockquote><p><a href="http://creativecommons.org/licenses/by-nc-sa/3.0/cn/" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaS5jcmVhdGl2ZWNvbW1vbnMub3JnL2wvYnktbmMtc2EvMy4wL2NuLzg4eDMxLnBuZw==.jpg"></a><br />
本文 由 <a href="http://www.cnblogs.com/coder2012/p/3142632.html" rel="external nofollow noreferrer">cococo点点</a> 创作，采用 <a href="http://creativecommons.org/licenses/by-nc-sa/3.0/cn/" rel="external nofollow noreferrer">知识共享 署名-非商业性使用-相同方式共享 3.0 中国大陆 许可协议</a>进行许可。欢迎转载，请注明出处：<br />
转载自：<a href="http://www.cnblogs.com/coder2012" rel="external nofollow noreferrer">cococo点点</a> <a href="http://www.cnblogs.com/coder2012" rel="external nofollow noreferrer">http://www.cnblogs.com/coder2012</a></p></blockquote>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-14 05:20:47</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/python/" title="python">python</a>, <a href="https://www.iamivan.net/tag/orm/" title="orm">orm</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>sqlalchemy(二)高级用法的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0WEKAb.html" rel="bookmark">C语言语法笔记 &ndash; 高级用法 指针数组 指针的指针 二维数组指针 结构体指针 链表 &vert; IT宅&period;com</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:C语言语法笔记 – 高级用法 指针数组 指针的指针 二维数组指针 结构体指针 链表 | IT宅.com C语言语法笔记 – 高级用法 指针数组 指针的指针 二维数组指针 结构体指针 链表 | IT宅.com C语言语法笔记 – 高级用法 指针数组 指针的指针 二维数组指针 结构体指针 链表本文由 arthinking 发表于315 天前 ⁄ itzhai.com原创文章 ⁄ C语言 ⁄ 评论数 3 ⁄ 被围观 1,775 views+   指针数组: 在一个数组中,如果它的元素全部都是指针			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVQ18Vp.html" rel="bookmark">Python爬虫二（Urllib库的基本使用和高级用法）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载:静觅 » Python爬虫入门三之Urllib库的基本使用 转载:静觅 » Python爬虫入门四之Urllib库的高级用法 1.分分钟扒一个网页下来 怎样扒网页呢?其实就是根据URL来获取它的网页信息,虽然我们在浏览器中看到的是一幅幅优美的画面,但是其实是由浏览器解释才呈现出来的,实质它是一段HTML代码,加 JS.CSS,如果把网页比作一个人,那么HTML便是他的骨架,JS便是他的肌肉,CSS便是它的衣服.所以最重要的部分是存在于HTML中的,下面我们就写个例子来扒一个网页下来. im			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XpmJjlz.html" rel="bookmark">Wordpress标签高级用法 你用对了吗？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用Wordpress建站的朋友,对标签是再熟悉不过了.对标签的使用也是各有各的看法,主要集中在两点:一种是倾向于屏蔽,另一种是不屏蔽.倾向于屏蔽的理由是随着文章的增多标签会越来越多,造成网站的臃肿;不屏蔽的理由是标签有利于搜索引擎的收录.笔者认为这个标签不应屏蔽,wordpress作为用户最多的博客程序之一,自然有其妙处.下面笔者就目前流行用法做一个罗列及评述,并提供一种高级用法,与网友分享. 一.华而不实的标签云 记得多年前,没有使用wordpress的时候,看到很多网友的博客,侧边栏上有个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAroyXp.html" rel="bookmark">Newtonsoft&period;Json高级用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:Newtonsoft.Json高级用法 手机端应用讲究速度快,体验好.刚好手头上的一个项目服务端接口有性能问题,需要进行优化.在接口多次修改中,实体添加了很多字段用于中间计算或者存储,然后最终用Newtonsoft.Json进行序列化返回数据,经过分析一个简单的列表接口每一行数据返回了16个字段,但是手机APP端只用到了其中7个字段,剩余9个字段的数据全部都是多余的,如果接口返回数据为40K大小,也就是说大约20K的数据为无效数据,3G网络下20K下载差不多需要1s,不返回无效数据至少可以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mvrkq8M.html" rel="bookmark">Fiddler &lpar;二&rpar; Script用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				来源:http://www.cnblogs.com/mrzhoushare/articles/4953592.html 来源:http://www.cnblogs.com/hushaojun/p/5644645.html 通过前一篇博客 [Fiddler教程],我们了解了Fiddler的基本用法,  现在我们来看看Fiddler的高级用法. Fiddler Script.   Fiddler中的script 可以让我们自动修改Http request和Response 的内容.  而不用手动地去			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZBE9az.html" rel="bookmark">细说 ASP&period;NET Cache 及其高级用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:细说 ASP.NET Cache 及其高级用法 许多做过程序性能优化的人,或者关注过程程序性能的人,应该都使用过各类缓存技术. 而我今天所说的Cache是专指ASP.NET的Cache,我们可以使用HttpRuntime.Cache访问到的那个Cache,而不是其它的缓存技术. 以前我在[我心目中的Asp.net核心对象] 这篇博客中简单地提过它,今天我打算为它写篇专题博客,专门来谈谈它,因为它实在是太重要了.在这篇博客中, 我不仅要介绍它的一些常见用法,还将介绍它的一些高级用法. 在上篇			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OM9g43z.html" rel="bookmark">ping的高级用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				高级 ping的高级用法 对于Windows下ping命令相信大家已经再熟悉不过了,但是能把ping的功能发挥到最大的人却并不是很多,当然我也并不是说我可以让ping发挥最大的功能,我也只不过经常用ping这个工具,也总结了一些小经验,现在和大家分享一下. 现在我就参照ping命令的帮助说明来给大家说说我使用ping时会用到的技巧,ping只有在安装了TCP/IP协议以后才可以使用: ping [-t] [-a] [-n count] [-l length] [-f] [-i ttl] [-v			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgKW03M.html" rel="bookmark">sscanf函数高级用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				大家都知道sscanf是一个很好用的函数,利用它可以从字符串中取出整数.浮点数和字符串等等.它的使用方法简单,特别对于整数和浮点数来说.但新手可能并不知道处理字符串时的一些高级用法,这里做个简要说明吧. 1. 常见用法. 以下是引用片段:char str[512] = {0};sscanf(&quot;123456 &quot;, &quot;%s&quot;, str);printf(&quot;str=%s\n&quot;, str); 2. 取指定长度的字符串.如在下例中,取最大长度为4字节的字符串			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgKqD6M.html" rel="bookmark">Excel自动筛选的9个高级用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  Excel自动筛选的9个高级用法            源表:A列为数字 1.筛选包含1的数字 很简单,在搜索框中输入1即可. 2.筛选以1开始的数字 在搜索框中输入1*,这里*是通配符,可以是任意多个字符. 3.筛选以1结尾的数字 在搜索框中输入*1. 4.筛选以至少包含2个1的数字 在搜索框中输入*1*1*. 5.筛选两个1之间隔一个数字的数字			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnRkKp.html" rel="bookmark" class="title">过滤驱动禁止U盘读写（非注册表）</a>
					<div>
						问题描述 过滤驱动禁止U盘读写(非注册表) 张帆的&lt;Windows 驱动开发技术详解&gt;中有一个U盘过滤驱动,实现U盘的只读锁定.我想在某种情况下实现U盘的读写锁定.因为我想做一个密码的判断 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMr5exb.html" rel="bookmark" class="title">php &lpar;十二&rpar; 面向对象 构造方法与析构方法</a>
					<div>
						1. 构造方法    大多数类都有一种称为构造函数的特殊方法.当创建一个对象时,它将自动调用构造函数,也就是使用new这个关键字来实例化对象的时候自动调用构造方法.     构造函数的声明与其它操作的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkn77M.html" rel="bookmark" class="title">php判断输入不超过mysql的varchar字段的长度范围</a>
					<div>
						但是如果在utf-8编码下,一个汉字是占3个字符长度的,比如字符串$str=&quot;你好啊!!&quot;; 如果你用strlen函数来判断,长度是11,正好超过了varchar的长度,但实际上确 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvQW6b.html" rel="bookmark" class="title">ASP&period;NET Whidbey 中新的代码编译功能</a>
					<div>
						asp.net|编译 ASP.NET Whidbey 中新的代码编译功能G. Andrew DuthieGraymad Enterprises, Inc. 2003 年 10 月 摘要:了解如何利用  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qba2D2M.html" rel="bookmark" class="title">时境变迁 网站建设制作时谷歌PR仍不可漠视</a>
					<div>
						就是今天,谷歌无奈移师香港近两年后,其权重表现因子PR,仍旧是众多网站交换链接时的重要参考因素.很多人也许不理解,既然谷歌已经非主流,而且慢慢的淡忘于人们视野,为什么依旧如此钟情Google PR呢? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvN06M.html" rel="bookmark" class="title">设计模式之观察者模式（Observer Pattern）&lpar;一&rpar;</a>
					<div>
						server|设计 我们通常在同一时间将我们的数据表示为各种不同的形式,比如列表.图形等等. 我们也同样希望当数据改变时,将这个更新信息很方便的通知所有依赖于它的各个对象. 例如:我们可以使用图形.表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLkxWM.html" rel="bookmark" class="title">Linux下C编程：信号处理</a>
					<div>
						信号处理是linux程序的一个特色.用信号处理来模拟操作系统的中断功能.要想使用信号处理功能,你要做的就是填写一个信号处理函数即可. #include &lt;stdio.h&gt; #include ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOOJ8M.html" rel="bookmark" class="title">一段将GB编码转换为utf8的php代码</a>
					<div>
						一段将GB编码转换为utf8的代码gb2utf8.php 文件如下: Class GB2UTF8 { var $gb;          // 待转换的GB2312字符串 var $utf8;     ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AQx6p.html" rel="bookmark" class="title">用一张图片来说说Photoshop蒙板</a>
					<div>
						蒙板,通道,图层混合,是PS学习中的三只拦路虎.我认为,之所以初学者觉得很难,关键是很多人在讲述他们应用的时候,把简单的问题给搞的复杂化了.比如蒙板,本来是个非常简单的问题,但我发现搞不明白的人是如此 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRXrqz.html" rel="bookmark" class="title">DELPHI图形编辑技巧二则</a>
					<div>
						一.界面色彩渐变效果的实现 界面色彩渐变效果是通过用渐变的画刷刷绘依次相邻的矩形块实现的.下面列举实例说明: 1.新建一个表单,假设其Width为500,设置一个按钮Button1,按此按钮将把表单置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLEP3b.html" rel="bookmark" class="title">万彩动画大师怎么给动画视频添加特效镜头</a>
					<div>
						  万彩动画大师怎么给动画视频添加特效镜头?缩放.旋转.移动的镜头特效让动画视频更富有镜头感,让观众拥有更好的视觉享受.添加别出心裁的镜头效果,让动画视频更加出彩.操作如下: 一.镜头-点击&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62DLoM.html" rel="bookmark" class="title">Photoshop制作发光的蓝色水晶字教程</a>
					<div>
						教程制作可能比较繁琐,需要用图层样式等把文字边缘的高光做出来,然后在通道里面单独把高光提取出来,新建图层后分别填充不同的颜色作为文字边缘的高光.然后再渲染整体光感即可. 最终效果 1.打开下图所示的背 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWN79p.html" rel="bookmark" class="title">金山词霸屏幕取词怎么用&quest;</a>
					<div>
						  在阅读英文文档时,经常遇到生词,需要查询词典,不是很便利.这里介绍使用金山词霸对PDF文档进行取词. 1.下载,安装金山词霸 2.勾选屏幕取词 3.这里找到插件设置,可以设置金山词霸对PDF取词  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6eDXyb.html" rel="bookmark" class="title">网络速度不行怎么办</a>
					<div>
						  网络速度不行怎么办?为啥家里装了20M.50M.100M的宽带,网速还跟蜗牛一样慢?简单一招,立即让你的电脑的网速恢复最高速度. 因为网速的传播跟网卡是有很大关系的,如果你家宽带升级到了20M.5 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WEVJb.html" rel="bookmark" class="title">aspx-客户端控件 &amp;amp&semi;amp&semi;lt&semi;input type&equals;&amp;amp&semi;amp&semi;quot&semi;button&amp;amp&semi;amp&semi;quot&semi; onclick&equals;&amp;amp&semi;amp&semi;quot&semi;sss&amp;amp&semi;amp&semi;quot&semi;</a>
					<div>
						问题描述 客户端控件 &lt;input type=&quot;button&quot; onclick=&quot;sss&quot; 客户端控件 我想点击这个按钮 激发后台的一个方法改怎么实现 解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN1rmxb.html" rel="bookmark" class="title">贪食蛇怎么走的这么奇葩&period;&period;&period;&period;</a>
					<div>
						问题描述 为什么这个蛇有的时候会一下走两格?一卡一卡的找了好久都没有找出错误....才这么点程序不会是电脑卡造成的吧,求大神帮忙看看[code=publicclassGameTest{publicst ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrW81M.html" rel="bookmark" class="title">求素数-java 求解大于Long&period;MAX&lowbar;VALUE的五个素数。。。</a>
					<div>
						问题描述 java 求解大于Long.MAX_VALUE的五个素数... 为什么运行没有结果啊!!!等着交作业呢...求一个简化的程序...至少能让我算出数字啊!!!或者大神帮我找一下错误啊...跪求 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPm2vp.html" rel="bookmark" class="title">c&num;-问大家一个关于sql server数据库的问题</a>
					<div>
						问题描述 问大家一个关于sql server数据库的问题 我建的一个表中有一列&quot;超期天数&quot;,我想对这一列执行计算,使其等于当前时间减去之前的一个时间.而且在用C#添加数据的时候,以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxGnOb.html" rel="bookmark" class="title">在线笔记Evernote继微软后成黑客目标</a>
					<div>
						本文讲的是 :   在线笔记Evernote继微软后成黑客目标 ,  在线笔记服务Evernote日前在一份安全公告中称,其网络遭到了不明身份黑客攻击,与账户有关的用户名.电子邮件及Evernote密 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXqRxz.html" rel="bookmark" class="title">DB2表空间管理详解&lpar;原创&rpar;</a>
					<div>
						create tablespace语法树 &gt;&gt;-CREATE --+-----------------------+----------------------------&gt;     ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKYrXb.html" rel="bookmark" class="title">MDI窗口管理的动态窗口排列？</a>
					<div>
						问题描述 MDI窗口管理的动态窗口排列? MDI窗口管理的动态窗口排列?怎么将窗口排列成层叠.平铺和分割这些效果? 解决方案 MDI Winform中窗口屏幕.级联等排列的实现					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLxo6p.html" rel="bookmark" class="title">工业级物联网项目的架构设计及实施</a>
					<div>
						早在1999年就已经有了&quot;物联网&quot;这个概念,但是直到十年之后的2009年,IBM提出&quot;智慧地球&quot;的概念,才推动很多国家把物联网研究和发展提升到战略层面.但是比较 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgorLM.html" rel="bookmark" class="title">《告别失控：软件开发团队管理必读》导读</a>
					<div>
						前言 告别失控:软件开发团队管理必读 软件开发常常被认为是难以管理的.进度安排和费用预算完全不靠谱的软件项目比比皆是.规范化的软件开发实践对这一状况有所改善,但也未能真正解决问题.我们软件开发行业已经 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeogJ7M.html" rel="bookmark" class="title">毕业两年，想跳槽，想延长IT生涯</a>
					<div>
						我不擅长做职场指导,但还是有人向我发来求助信,也就有关问题谈了些个人的看法,直接批注在原文上. 我给他回信的结语是:不要犹豫,向前走一步,海阔天空. [来信及我的批注] 我是一个小小的码农,最近对于生 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5gAEp.html" rel="bookmark" class="title">visual basic 6&period;0-Visual Basic 6&period;0问一个selstart的问题</a>
					<div>
						问题描述 Visual Basic 6.0问一个selstart的问题 VB TextBox控件中用selstart属性选择下一个制表位,按下-&gt;怎么移动选择的制表位文本? 解决方案 窗体的Ke ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAE3gJM.html" rel="bookmark" class="title">2014秋C&plus;&plus;第13周OJ题目参考</a>
					<div>
						课程主页在http://blog.csdn.net/sxhelijian/article/details/39152703,课程资源在云学堂&quot;贺老师课堂&quot;同步展示,使用的帐号请到课 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0n5vPz.html" rel="bookmark" class="title">WPF程序：图像的ARGB数字矩阵输出。发现某些像素点结果不正确。谁帮忙看看哪里出了问题？</a>
					<div>
						问题描述 代码如下,运行即可.&lt;Windowx:Class=&quot;Test.MainWindow&quot;xmlns=&quot;http://schemas.microsoft.com ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqxwAp.html" rel="bookmark" class="title">简单的编程0基础下Python入门指引&lowbar;python</a>
					<div>
						 你曾经想知道计算机是如何工作的吗?尽管我们不能在一篇文章里面教会你所有的东西,但是可以通过学习如何写出你自己的程序来获得一个良好的开端.在这篇Python教程中,你将会学到计算机编程的基础知识,使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvxkyM.html" rel="bookmark" class="title">php输入数据统一类实例&lowbar;php技巧</a>
					<div>
						本文实例讲述了php输入数据统一类.分享给大家供大家参考.具体如下: &lt;?php class cls_request{ private $getdata;//存储get的数据 private $ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ZeLVb.html" rel="bookmark" class="title">为什么我用spring注解读不到我配置文件里面的值&quest;&quest;</a>
					<div>
						问题描述 为什么我用spring注解读不到我配置文件里面的值?? //运用注解读取配置文件 @Component @ComponentScan @Configuration @PropertySour ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
